---

# Создание run-инсталляторов.

---

[[toc]]

---

## Что такое run-инсталляторы.

---

Инсталляторы **\*.run** - это саморапаковывающиеся инсталляционные архивы,
сделанные на основе **bash** скриптов (сценариев) с помощью утилиты
**makeself** (установка - **`sudo apt install makeself`**).
Инсталляционный сценарий вместе с архивами упаковывается в один исполняемый
файл **\*.run**, так что для инсталляции надо просто запустить этот файл.
Его также удобно копировать (всё упаковано в один файл) и переносить.

---

## Как создать run-инсталлятор.

---

В папке проекта (например, **demo**) заведите (скопируйте из шаблона **generic**)
файлы:

| Файл/Каталог                             | Пояснение                                                 |
|------------------------------------------|-----------------------------------------------------------|
| **demo**                                 | каталог проекта demo                                      |
| **demo/build-demo.sh**                   | сценарий создания инсталлятора, копия build-generic.sh    |
| **demo/payload-demo**                    | каталог данных инсталлятора                               |
| **demo/payload-demo/install-demo.sh**    | сценарий инсталляции, по шаблону install-generic.sh       |
| **demo/payload-demo/install-library.sh** | общая библиотека (одинаковая для всех инсталляторов)      |
| **demo/payload-demo/demo.tar**           | архив файлов, нужных для инсталлятора                     |

При запуске **build-demo.sh** в каталоге **demo** будет сгенерирован инсталляционный файл **install-demo.run**.

Призапуске файла **install-demo.run** содержимое **payload-demo** будет развернуто во временном каталоге,
а затем в нём будет запущен инсталляционный сценарий **install-demo.sh**.
Предполагается, что этот сценарий развернет архив **demo.tar** в нужное место и выполнит все действия,
необходимые для инстлляции.



